﻿-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

local function Hedd_findclass()
	local talenttree = GetPrimaryTalentTree() or 4
	if lib.classes[cfg.class] and lib.classes[cfg.class][talenttree] then
		cfg.classfound=true
		return lib.classes[cfg.class][talenttree]()
	end
	cfg.classfound=nil
	return false
end

lib.basicevents = function()
	function Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
		local cdupdate=nil
		for index,name in pairs(cfg.spells) do
			if cfg.spells[index] and not cfg.spells[index].noupdate and lib.UpdateSpellCD(cfg.spells[index]) then cdupdate=true end
		end
		if cdupdate then cfg.Update=true end
	end

	function Heddevents:ACTIONBAR_UPDATE_STATE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

	function Heddevents:ACTIONBAR_UPDATE_USABLE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

	function Heddevents:SPELL_UPDATE_USABLE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

--[[function Heddevents:UNIT_POWER(unit,...)
	if unit=="player" then
		cfg.power=UnitPower("player")
		print (cfg.power)
	end
end]]

	function Heddevents:UNIT_AURA(unitID)
		if cfg.watchunits[unitID] and UnitExists(unitID) then
			local bupdate=nil
			for index,name in pairs(cfg.auras) do
				if cfg.auras[index].unit==unitID and lib.UpdateAura(cfg.auras[index]) then
					bupdate=true
				end
			end
			if bupdate then
				cfg.Update=true
			end
		end
	end

	function Heddevents:PLAYER_TARGET_CHANGED()
		Heddevents:UNIT_AURA("target")
	end
	
	function Heddevents:PLAYER_ENTERING_WORLD()
		local update=nil
--[[		for index,name in pairs(cfg.spells) do
			if lib.UpdateSpellCD(cfg.spells[index]) then update=true end
		end
		
		for index,name in pairs(cfg.auras) do
			if lib.UpdateAura(cfg.auras[index]) then update=true end
		end]]
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
		Heddevents:UNIT_AURA("player")
		Heddevents:UNIT_AURA("target")
		
		if lib.mypew then
			if lib.mypew() then
				update=true
			end
		end
		
		if update then
			cfg.Update=true
		end
	end
	
	function Heddevents:PLAYER_REGEN_ENABLED()
		cfg.casting={}
	end
end

lib.spellcastevents = function()
	cfg.lastspell=nil
	
	function Heddevents:UNIT_SPELLCAST_START(u,spellname)
		if u=="player" then
			local p = cfg.casting[spellname]
			cfg.casting[spellname]="casting"
			if cfg.casting[spellname]~=p then cfg.Update=true end
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_DELAYED(u,spellname)
		Heddevents:UNIT_SPELLCAST_START(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_CHANNEL_START(u,spellname)
		Heddevents:UNIT_SPELLCAST_START(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_CHANNEL_UPDATE(u,spellname)
		Heddevents:UNIT_SPELLCAST_START(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
		if u=="player" then
			local p = cfg.casting[spellname]
			cfg.casting[spellname]="notcasting"
			if cfg.casting[spellname]~=p then cfg.Update=true end
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(u,spellname)
		Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
		cfg.lastspell=spellname
	end
	
	function Heddevents:UNIT_SPELLCAST_INTERRUPTED(u,spellname)
		Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_FAILED(u,spellname)
		Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_CHANNEL_STOP(u,spellname)
		Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
	end
	
--[[	function Heddevents:UNIT_SPELLCAST_SENT(u,spellname)
		if u=="player" then
			local p = cfg.casting[spellname]
			cfg.casting[spellname]="casting"
			if cfg.casting[spellname]~=p then cfg.Update=true end
--			print(cfg.now.." sent "..spellname)
		end
	end]]
	
end

local lastUpdate=0
cfg.Update=nil

local function Hedd_onupdate(self, elapsed)
	lastUpdate = lastUpdate + elapsed
	cfg.now = GetTime()
	if cfg.Update or lastUpdate > cfg.UpdateTime then
--		local update = lib.myonupdate and true or nil
		
		local ppower=cfg.power
		cfg.power=UnitPower("player")
	
		if cfg.power~=ppower then
			if lib.myonpowerupdate then
				lib.myonpowerupdate()
			end
			
			if cfg.onpower then
				cfg.Update=true
			end
		end
		
		local phealth=cfg.health
		cfg.health=UnitHealth("target")
		
		if cfg.health~=phealth then
			if lib.myonhealthupdate then
				lib.myonhealthupdate()
			end
			
			if cfg.onhealth then
				cfg.Update=true
			end
		end
				
		if lib.myonupdate then
			lib.myonupdate()
		end
		
		if lib.rangecheck then
			lib.rangecheck()
		end
		
		if cfg.Update then
			lib.SetPriority()
		end
		
		lastUpdate = 0
		cfg.Update=nil
	end
end

local function Heddtal_onevent(self,event)
	for index,name in pairs(cfg.spells) do
		lib.HideFrame(cfg.spells[index].f)
	end
	Heddframe:Hide()
	
	lib.defaults()
	
	Heddframe:UnregisterAllEvents()
	Heddframe:SetScript("OnEvent",nil)
	Heddframe:SetScript("OnUpdate",nil)
	if Hedd_findclass() then
		lib.basicevents()
		if cfg.spellcaster then lib.spellcastevents() end
		if lib.classevents[cfg.class] then lib.classevents[cfg.class]() end
		
		cfg.case["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
			return true
		end
		
		cfg.numcase=0
		for key, value in pairs(cfg.plist) do
			cfg.numcase=cfg.numcase+1
		end
		cfg.numcase=cfg.numcase+1
		
		Heddframe:SetScript("OnEvent", function(self, cevent, ...)
			if not cfg.classfound then return end
			Heddevents[cevent](_,...)
		end)

		for k, v in pairs(Heddevents) do
			Heddframe:RegisterEvent(k) -- Register all Heddevents for which handlers have been defined
		end
		
--		if cfg.onupdate then
			Heddframe:SetScript("OnUpdate", Hedd_onupdate)
--		end
		
		if lib.mytal then
			lib.mytal()
		end
		
		Heddevents:PLAYER_ENTERING_WORLD()
		Heddframe:Show()
	end
	
end

cfg.notloaded=true
local function Heddframe_pew(self,...)
	if cfg.notloaded then 
--		print("PEW")
		cfg.notloaded=nil
		Heddframe:UnregisterEvent("PLAYER_ENTERING_WORLD")
		Heddframe:RegisterForClicks("AnyUp")
		Heddframe:SetScript("OnClick", function (self, button, down)
		if lib.onclick then lib.onclick() end
		end);

		Heddtalents:SetScript("OnEvent",Heddtal_onevent)
		Heddtalents:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		Heddtalents:RegisterEvent("CHARACTER_POINTS_CHANGED")
		Heddtalents:RegisterEvent("PLAYER_TALENT_UPDATE")

		Heddtal_onevent()
	end
end


Heddframe:SetScript("OnEvent",Heddframe_pew)
Heddframe:RegisterEvent("PLAYER_ENTERING_WORLD")
